#include  <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

/* max liczba utworzonych watkow */
#define MAX 4

/* Funkcja. ktora bedzie wykonywal kazdy watek */
void * watek1 (void *);
void * watek2 (void *);
void * watek3 (void *);
void * watek4 (void *);

int main ()
{
   int i, iA, iB, iC, iD;

   /* Identyfikatory watkow beda w tej tablicy */  
   pthread_t thread_id[MAX];   

   /* adres komorki pamieci, w ktorej bedzie
      przechowywane to, co zwroci nam funkcja 
      watkowa (wskaznik na to)
   */
   int status, *p_status=&status;
  
   /* Tworzenie watkow 
      kolejno argumenty:
      - identyfikator watku (ta f-cja zwraca te wartosc
        po utworzeniu watku
      - zestaw argumentow dla watku, tu: domyslne
      - funkcja wykonywana w ramach watku (musi byc void,
        dlatego na poczatku, przy daklaracji bylo
        tzw. rzutowanie)
      - argumenty tej funkcji (tez void - rzutwany)
   */

   printf("\n\n Program obliczajacy rownanie: ");
   printf("\n\t  A*A*A + B/(B+0.234) + C*C + D*D*0.1");
   printf("\n z udzialem czterech watkow");

   printf("\n\n\tPodaj wartosci calkowitoliczbowe");
   printf("\n\t A : ");
   scanf("%d", iA);   
   printf("\n\t B : ");
   scanf("%d", iB);   
   printf("\n\t C : ");
   scanf("%d", iC);   
   printf("\n\t D : ");
   scanf("%d", iD);   

   printf("\n\n\t\t Tworze watki");

   /* 1-szy watek */
   if (pthread_create(&thread_id[0],NULL,watek1,(void *) iA)>0)
   {
      fprintf (stderr, "\n Niepowodzenie: pthread_create \n");
      exit(1);
   }

   /* 2-gi watek */
   if (pthread_create(&thread_id[1],NULL,watek2,(void *) iB)>0)
   {
      fprintf (stderr, "\n Niepowodzenie: pthread_create \n");
      exit(1);
   }
   
   /* 3-ci watek */
   if (pthread_create(&thread_id[2],NULL,watek3,(void *) iC)>0)
   {
      fprintf (stderr, "\n Niepowodzenie: pthread_create \n");
      exit(1);
   }

   /* 4-ty watek */
   if (pthread_create(&thread_id[3],NULL,watek4,(void *) iD)>0)
   {
      fprintf (stderr, "\n Niepowodzenie: pthread_create \n");
      exit(1);
   }
  
   /* Wcielanie watkow - koniec dzialania watkow */
   for(i=0; i<MAX; i++)
   {
      if (pthread_join(thread_id[i],(void * *) p_status)>0)
      {
         fprintf (stderr, "\n Niepowodzenie: pthread_join \n");
         exit(2);
      }
   }	
  
   printf ("\n Koniec.\n');
   return (void *) NULL;

}

/* Funkcje, ktora bedza realizowac watki 
*/

void *watek1 (void *iX)
{
   int iX=*iX;
   int iWynik;

   printf("\n Watek 1 zostal powolany do zycia.");
   wynik = iX*iX*iX;
   printf("\n Watek 1 konczy sie");
   return iWynik;
}

void *watek2 (void *iX)
{
   int iX=*iX;
   int iWynik;

   printf("\n Watek 2 zostal powolany do zycia.");
   wynik = iX/(iX+0.234);
   printf("\n Watek 2 konczy sie");
   return iWynik;
}

void *watek3 (void *iX)
{
   int iX=*iX;
   int iWynik;

   printf("\n Watek 3 zostal powolany do zycia.");
   wynik = iX*iX;
   printf("\n Watek 3 konczy sie");
   return iWynik;
}

void *watek4 (void *iX)
{
   int iX=*iX;
   int iWynik;

   printf("\n Watek %d zostal powolany do zycia.",numer);
   wynik=iX*iX*0.1;
   printf("\n Watek %d konczy sie",numer);
   return iWynik;
}